// Untahris (Common Playground)
// copyright (C) 2006 longuens@users.sourceforge.net
// Released under GNU General Public License (see the file COPYING)
// --------------------------------------------------------------
// Worm.

#define NOROPE -999 // rx is set to this value if we have no ninja rope

int pblocker; // player who blocks, dirty hack

struct OWorm : TPlayObject {
  public:
  
  int32 x;
  int32 y;
  int32 dx;
  int32 dy;
  
  int32 rx;
  int32 ry;
  int32 drx;
  int32 dry;
  
  int32 dir;
  bool faceLeft;
  bool onFloor;
  
  bool dead;
  
  int32 lastKey;
  
  OWorm(int _owner, int _x, int _y) : 
    x(Ctr(_x)), y(Ctr(_y)) {
    owner = _owner;
    time = g.time;
    dx = 0; dy = 0; dir = 45;
    rx = NOROPE;
    faceLeft = _x > g.sizeX / 2;
    lastKey = 0;
    g.objects.push_back(this);
    dead = false;
    }
  
  OWorm(TBuffer &b) {
    b.get(owner); 
    b.get(x); b.get(y);
    b.get(dx); b.get(dy);
    b.get(rx); b.get(ry);
    b.get(drx); b.get(dry);
    b.get(time); b.get(dir);
    b.get(faceLeft);
    b.get(onFloor);
    b.get(lastKey);
    dead = false;
    }
  void save(TBuffer &b) {
    b.putChar(12);
    b.put(owner); 
    b.put(x); b.put(y);
    b.put(dx); b.put(dy);
    b.put(time); b.put(dir);
    b.put(faceLeft);
    b.put(onFloor);
    b.put(lastKey);
    }

  int oo;
  
  bool testBlock(int x, int y) {
    int nx = DeCtr(x);
    int ny = DeCtr(y);
    if(nx<0) nx = 0;
    if(ny<0) ny = 0;
    if(nx>g.sizeX-1) nx = g.sizeX-1;
    if(ny>g.sizeY-1) ny = g.sizeY-1;
    CellType m = bigType(nx, ny);
    oo = g.owner[ny][nx];
    if(m != cFree && m != cCannonA && m != cCannonF) {
      switch(m) {
        case cBonusLevel:
          d.playSoundAt(d.sndBlue, nx, ny);
          ow()->level ++;
          ow()->score += scoreGain() * 10;
          break;
        case cBonusScore: 
          d.playSoundAt(d.sndGreen, nx, ny);
          ow()->score += scoreGain();
          break;
        case cBonusAmmo:
          d.playSoundAt(d.sndRed, nx, ny);
          ow()->gainAmmo();
          ow()->score += scoreGain();
          break;
        }
      if(gc.regenerate(m)) 
        placeBigRandomly(m, 0);
      clearBig(nx, ny, cFree, 0);
      }
    if(g.map[ny][nx] == cXunux) {
      destroyAt(nx, ny, owner, 0);
      }
    if(g.map[ny][nx] == cFree) return false;
/*  if(g.map[ny][nx] == cExplosion || g.map[ny][nx] == cSnakeHead ||
       g.map[ny][nx] == cTetris) {
      if(!dead) {
        d.playSoundAt(d.sndDeath, nx, ny);
        dead = true; 
        killedBy(oo);
        }
      return true;
      } */
    pblocker = oo;
    return true;
    }
  
  bool digAt(int x, int y) {
    if(x<0) x = 0;
    if(y<0) y = 0;
    if(x>g.sizeX-1) x = g.sizeX-1;
    if(y>g.sizeY-1) y = g.sizeY-1;
    destroyAt(x, y, owner);
    }
  
  bool blockedAt(int nx, int ny) {
    bool b;
    b =  testBlock(nx - 128, ny - 512);
    b |= testBlock(nx - 128, ny + 511);
    b |= testBlock(nx + 128, ny - 512);
    b |= testBlock(nx + 128, ny + 511);
    return b;
    }
  
  int adjustDir() {
    if(faceLeft) return (360 - dir) % 360;
    return dir;
    }
  
  void go() {
    dy += 12;
    if(g.pl[owner]->key[keyUp]) dir -= 10;
    if(g.pl[owner]->key[keyDown]) dir += 10;
    if(g.pl[owner]->key[keyUp] && g.pl[owner]->key[keyDown]) 
      if(lastKey == keyUp) dir--; else dir++;
    if(dir < 0) dir = 0;
    if(dir > 180) dir = 180;
    if(g.pl[owner]->key[keyAir] && onFloor) {
      dy = -384;
      }
    if(g.pl[owner]->key[keyLeft]) {
      faceLeft = true;
      dx -= gc.wormFlySpeed;
      if(onFloor) dx -= gc.wormWalkSpeed;
      }
    if(g.pl[owner]->key[keyRight]) {
      faceLeft = false;
      dx += gc.wormFlySpeed;
      if(onFloor) dx += gc.wormWalkSpeed;
      }
    bool b = false;
    int oo2 = ow()->index;
        
    if(rx != NOROPE) {
      int steps = 1 + calcDistance(drx, dry) / 512;
      
      bool hooked = false;
      
      int xdrx = drx, xdry = dry;

      while(steps && !hooked) {
      
        int dist = calcDistance(rx-x, ry-y);
        if(dist > gc.ninjaRopeLength * 1024) { rx = NOROPE; break; }
        else {
          int nrx = DeCtr(rx);
          int nry = DeCtr(ry);
          if(nrx<0) nrx = 0;
          if(nry<0) nry = 0;
          if(nrx>g.sizeX-1) nrx = g.sizeX-1;
          if(nry>g.sizeY-1) nry = g.sizeY-1;
          if(g.map[nry][nrx] != cFree)
            hooked = true;
          }
      
        TPlayObject *ohook = NULL;
        if(!hooked) {
          for(int o=0; o<size(g.objects); o++) if(g.objects[o])
            if(g.objects[o] != this)
            if(g.objects[o]->catchesRope(rx, ry)) ohook = g.objects[o];
          if(ohook) hooked = true;
          }
        
        if(!hooked) {
          int sx = xdrx/steps; rx += sx; xdrx -= sx;
          int sy = xdry/steps; ry += sy; xdry -= sy;
          steps--;
          }
        else {
          drx = 0;
          dry = 0;
          
          int pull = g.pl[owner]->key[keyAir] ? gc.ninjaPullSpeed :
            dist > (gc.ninjaRopeLength-1) * 1024 ? gc.ninjaPullSpeed : 0;
            
          int ddx = 0, ddy = 0;
          
          if(pull) {
            ddx = ((rx - x) * pull) / dist;
            ddy = ((ry - y) * pull) / dist;
            
            if(ddx != 0 || ddy != 0) 
            do {
              dx += ddx;
              dy += ddy;
              }
            while(dx * ddx + dy * ddy <= 500);
            }
          
          if(ohook) ohook->pullRope(this, ddx, ddy);
          }
        }
      
      if(!hooked) dry += 12;
      }

    // limit the worm speed to one cell per tick
    if(dx > 1024) dx = 1024;
    if(dx < -1024) dx = -1024;
    if(dy > 1024) dy = 1024;
    if(dy < -1024) dy = -1024;
    
    if(blockedAt(x+dx, y)) dx = 0; else x += dx;
    if(blockedAt(x, y+dy)) {
      onFloor = dy > 0;
      dy = 0, dx = dx * 3/4;
      y = Ctr(DeCtr(y));
      }
    else y += dy, onFloor = false;
    
    if(blockedAt(x, y)) {
      int nx = DeCtr(x);
      int ny = DeCtr(y);
      d.playSoundAt(d.sndDeath, nx, ny);
      killedBy(pblocker);
      }
    
//  dx *= 255/256;
//  dy *= 255/256;
    
    time += spd();
    }
  void draw() {
    int adir = adjustDir();
    if(faceLeft)
      DIc(icWorm).drawAtCenteredFlipped(CTG(x), CTG(y));
    else
      DIc(icWorm).drawAtCentered(CTG(x), CTG(y));
    DIc(icBazooka).drawAtRotated(CTG(x), CTG(y), degx[adir], degy[adir]);
    if(rx != NOROPE)
      for(int p=0; p<400; p++)
        d.putpix(d.ofsX + CTG(x+(rx-x)*p/400), d.ofsY + CTG(y+(ry-y)*p/400), ow()->color);
    }
  void reactToKey(PlayerKey pk, bool pressed) {
    if(!pressed) return;
    int adir = adjustDir();

    if(pk == keyUp || pk == keyDown) lastKey = pk;

    if(pk == keyFire && ow()->useAmmo()) {
      d.playSoundAt(d.sndShoot, DeCtr(x), DeCtr(y));
      new OBullet(owner, x + degx[adir] * 8, y + degy[adir] * 8, 
        dx/spd() + (degx[adir] * bulletSpeed()) / 128, dy/spd() + (degy[adir] * bulletSpeed()) / 128);
      }

    if(pk == keyEarth) {
      int nx = DeCtr(x);
      int ny = DeCtr(y);
      d.playSoundAt(d.sndHit, nx, ny);
      digAt(nx, ny);
      if(dir > 22 && dir < 158) if(faceLeft) nx--; else nx++;
      digAt(nx, ny);
      if(dir < 67) ny--;
      if(dir > 113) ny++;
      digAt(nx, ny);
      }

    if(pk == keyWater) {
      if(rx == NOROPE) {
        d.playSoundAt(d.sndShoot, DeCtr(x), DeCtr(y));
        rx = x + degx[adir] * 8;
        ry = y + degy[adir] * 8;
        drx = dx + (degx[adir] * bulletSpeed() * spd()) / 128;
        dry = dy + (degy[adir] * bulletSpeed() * spd()) / 128;
        }
      else rx = NOROPE;
      }
    }
  bool reactToThruster(OThruster *enemy) {
    if(calcDistance(x-enemy->x, y-enemy->y) < 8*128 + 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      int oe = enemy->owner;
      killedBy(oe);
      return true;
      }
    return false;
    }
  bool smashedByBall(OBall *enemy) {
    if(calcDistance(x-enemy->x, y-enemy->y) < 512 + 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      killedBy(enemy->owner);
      return true;
      }
    return false;
    }
  bool reactToBullet(OBullet *bullet) {
    if(calcDistance(x-bullet->x, y-bullet->y) < 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      killedBy(bullet->owner);
      return true;
      }
    return false;
    }
  void reactToCannon(OCannonball *ball) {
    if(calcDistance(x-ball->tx, y-ball->ty) < 512 + 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      killedBy(ball->owner);
      }
    }
  bool catchesRope(int rx, int ry) {
    if(calcDistance(x-rx, y-ry) < 512) {
      return true;
      }
    return false;
    }
  void pullRope(OWorm *worm, int ddx, int ddy) {
    worm->rx = x; worm->ry = y; worm->drx = dx; worm->dry = dy;
    dx -= ddx; dy -= ddy;
    }
  };

void OThruster::pullRope(OWorm *worm, int ddx, int ddy) {
  worm->rx = x; worm->ry = y; worm->drx = dx; worm->dry = dy;
  dx -= ddx/3; dy -= ddy/3;
  }

void OPad::pullRope(OWorm *worm, int ddx, int ddy) {
  worm->rx = x; worm->ry = y;
  }

void OBomber::pullRope(OWorm *worm, int ddx, int ddy) {
  worm->rx = x; worm->ry = y;
  }

void OBall::pullRope(OWorm *worm, int ddx, int ddy) {
  worm->rx = x; worm->ry = y;
  worm->drx = degx[dir] * worm->spd() / speed;
  worm->dry = degy[dir] * worm->spd() / speed;
  
  int di1 = (dir + 8) % 360;
  int di2 = (dir + 360 - 8) % 360;

  // use the scalar product to determine the new direction for the ball
  if(ddx || ddy) {
    int d1 = degx[di1] * ddx + degy[di1] * ddy;
    int d2 = degx[di2] * ddx + degy[di2] * ddy;
  
    if(d1 < d2) dir = di1; else dir = di2;
    }
  }
