// Untahris (Common Playground)
// copyright (C) 2006 longuens@users.sourceforge.net
// Released under GNU General Public License (see the file COPYING)
// --------------------------------------------------------------
// Xunux

struct OXunux : TPlayObject {
  public:
  int32 x;
  int32 y;
  int32 dir;
  bool stopped;

  OXunux(int _owner, int _x, int _y, int _dir) : x(_x), y(_y), dir(_dir) {
    owner = _owner;
    g.mapSet(x,y, cXunux, owner);
    stopped = true;
    time = g.time;
    g.objects.push_back(this);
    }
  OXunux(TBuffer &b) {
    b.get(owner);
    b.get(x); b.get(y); b.get(time); b.get(dir); b.get(stopped);
    }
  void save(TBuffer &b) {
    b.putChar(13);
    b.put(owner); b.put(x); b.put(y); b.put(time); b.put(dir); b.put(stopped);
    }
  void go() {
    if(g.map[y][x] != cXunux) {
      // it seems something killed us...
      d.playSoundAt(d.sndDeath, x, y);
      killedBy(ow()->killer);
      return;
      }
    int sx=x, sy=y;
    if(stopped) {
      time += spd();
      return;
      }
    x += kx[dir];
    y += ky[dir];
    CellType m = bigType(x,y);
    if(m != cFree && m != cCannonA && m != cCannonF) {
      if(m == cBonusScore) {
        d.playSoundAt(d.sndGreen, x, y);
        ow()->score += scoreGain() * 2;
        }
      if(m == cBonusLevel) {
        d.playSoundAt(d.sndBlue, x, y);
        ow()->score += scoreGain() * 10;
        int ospd = spd();
        ow()->level++;
        }
      if(m == cBonusAmmo) {
        d.playSoundAt(d.sndRed, x, y);
        ow()->score += scoreGain();
        ow()->gainAmmo();
        }
      placeBigRandomly(m, 0);
      clearBig(x, y, cFree, 0);
      }
    if(g.map[y][x] == cXunux) {
      int oo = g.owner[y][x];
      if(gc.xunuxAttacksXunux) destroyAt(x, y, owner, 0);
      if(gc.xunuxKillsXunux) destroyAt(sx, sy, oo, 0);
      time += spd();
      x=sx; y=sy;
      }
    else if(g.map[y][x] == cFree) {
      g.mapSet(x,y, cXunux, owner);
      time += spd();
      }
    else if(g.map[y][x] == cPermaWall) {
      x = sx; y = sy;
      stabilize(x, y);
      g.map[sy][sx] = cXunux;
      time += spd();
      }
    else if(isXunuxStabilizer(g.map[y][x])) {
      stabilize(sx, sy);
      g.mapSet(x,y, cXunux, owner);
      time += spd();
      return;
      }
    else {
      killedBy(g.owner[y][x]);
      destroyAt(sx, sy, owner, 0);
      }
    }
  void reactToKey(PlayerKey pk, bool pressed) {
    if(!pressed) {
      if(int(pk) < 4 && dir == int(pk)) stopped = true;
      return;
      }
    if(int(pk)<4 && (stopped || int(pk) != (dir^2))) dir = int(pk), stopped = false;
    if((pk == keyFire || pk == keyEarth || pk == keyAir || pk == keyWater) && ow()->useAmmo()) {
      d.playSoundAt(d.sndShoot, x, y);
      new OBullet(owner, Ctr(x) + kx[dir] * 2048, Ctr(y) + ky[dir] * 2048, kx[dir] * bulletSpeed(), ky[dir] * bulletSpeed());
      }
    }
  };
